/*
  -: Copyright  1999-2004 AY-programs. All Rights Reserved. :-    
                  E-mail: ay@supermail.ru 
*/

#include <math.h>

#define PRECISION 1E-8

double Minimum(double a, double b, double (*f)(double));
double G(double x);
int main(int argc, char* argv[])
{
	double a,b;
	printf("Input a=");
	scanf("%lg",&a);
	printf("Input b=");
	scanf("%lg",&b);
	printf("Minimum(%lg,%lg,cos(x))=%lg\n",a,b,Minimum(a,b,cos));
	return 0;
}

double Minimum(double a, double b, double (*f)(double))
{
	double dGS1, dGS2;
	double dX1, dX2;
	double dF_X1, dF_X2;
	// ---- //
	dGS1=(3-sqrt((double)5))/2;
    dGS2=(sqrt((double)5)-1)/2;
	// ---- //
    dX1=a+dGS1*(b-a);
    dX2=a+dGS2*(b-a);
	dF_X1=(*f)(dX1);
	dF_X2=(*f)(dX2);
	// ---- //
	while (b-a>=2*PRECISION) {
		if (dF_X1<=dF_X2) {
			b=dX2;
			dX2=dX1;
			dF_X2=dF_X1;
			dX1=a+dGS1*(b-a);
            dF_X1=(*f)(dX1);
		} else {
			a=dX1;
			dX1=dX2;
			dF_X1=dF_X2;
			dX2=a+dGS2*(b-a);
            dF_X2=(*f)(dX2);
		}
	}
	return ((a+b)/2);
}

double G(double x)
{
	return (x*x-2*x);
}

/*
  -: Copyright  1999-2004 AY-programs. All Rights Reserved. :-    
                  E-mail: ay@supermail.ru 
*/
